#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "imclient.h"

#define __err1__	"\n\
       -nshm <nf>         - имя файла данных(в /dev/shm - разделяемая память)\n\
       -smfshm <nf>       - имя семафора(в /dev/shm - разделяемая память)\n\
       -szshm <size>      - размер разделяемой памяти\n\
\n"


SSHM sshm;

char 		SEMAPHORE_NAME[256];			// "/test_named_semaphore"
char 		SHARED_MEMORY_OBJECT_NAME[256]; 	// "test_shared_memory"
u_int64_t	SHARED_MEMORY_OBJECT_SIZE;

int main(int argc, char **argv)
{
        int cnt;
        int scnt = 1;
	u_int8_t	dump[256];
        //
        if(argc < 2)
        {
                printf(__err1__);
                return 1;
        }
	memset(&SEMAPHORE_NAME[0], 0, 256);
	memset(&SHARED_MEMORY_OBJECT_NAME[0], 0, 256);
	SHARED_MEMORY_OBJECT_SIZE	= 0;
	while (scnt < argc)
	{
		if(strcmp(argv[scnt],"-smfshm") == 0)
		{
			scnt++;
			if(!(scnt < argc))
                                return 2;
			strcpy(&SEMAPHORE_NAME[0], argv[scnt]);
		}
		else if(strcmp(argv[scnt],"-nshm") == 0)
		{
			scnt++;
			if(!(scnt < argc))
                                return 2;
			strcpy(&SHARED_MEMORY_OBJECT_NAME[0], argv[scnt]);
		}
		else if(strcmp(argv[scnt],"-szshm") == 0)
		{
			scnt++;
			if(!(scnt < argc))
                                return 2;
			SHARED_MEMORY_OBJECT_SIZE = atoi(argv[scnt]);
		}
		scnt++;
	}
	if((strcmp(&SEMAPHORE_NAME[0], "") == 0) ||
	(strcmp(&SHARED_MEMORY_OBJECT_NAME[0], "") == 0) || 
	(SHARED_MEMORY_OBJECT_SIZE == 0))
	{
		printf("не определены параметры разделяемой памяти\n");
		return 11;
	}
	_SshMemCreate(&SHARED_MEMORY_OBJECT_NAME[0], &SEMAPHORE_NAME[0], 256, &sshm);
	//начальное заполнение буфера
	cnt = 0;
	while(cnt < 256)
	{
		dump[cnt] = (u_int8_t)(cnt);
		cnt++;
	}
	// первая запись блока
	_SshMemBlockWriete(&dump[0], 0, 256, &sshm);
	while(1)
	{
		//чтение блока
		_SshMemBlockRead(&dump[0], 0, 256, &sshm);
		cnt = 0;
		while(cnt < 256)
		{
			if(dump[cnt] < 255)
				dump[cnt]++;
			else
				dump[cnt] = 0;
			cnt++;
		}
		//запись блока
		_SshMemBlockWriete(&dump[0], 0, 256, &sshm);
		usleep(10000);
	}
	//
	return 0;
}

